   Device 16F628A

  '  Remarks=On

	Reminders = OFF
    Config WDT_OFF, BODEN_ON, INTRC_OSC_NOCLKOUT, LVP_OFF, CP_OFF, DATA_CP_OFF, PWRTE_ON, MCLRE_ON			
	Reminders = On

    Declare Xtal = 4 

     Symbol L1 = PORTA.0
     Symbol L2 = PORTA.1
     Symbol L3 = PORTA.2
     Symbol L4 = PORTA.3
     Symbol L5 = PORTA.4
     Symbol L6 = PORTA.6
     Symbol PS = 1500
     Symbol V  = PORTA.7
    
     Dim FREQ As Byte
     Dim LCDRam_0[6] As Byte
     Dim i As Byte
     Dim j As Byte
     Dim t As Byte
     TRISA=%10000000	 			' Set PORTA for OUTPUT (except A.6 -> POT). In charge of LINES 
     TRISB=%00000000				' Set PORTB for OUTPUT. In charge of columns
     'CMCON = 7
     All_Digital = On
INIT:
     Low L1: Low L2 : Low L3: Low L4: Low L5: Low L6		' All LEDs OFF
     
     PORTA.5 = 0
     
BEGIN:
     	  FREQ = Pot V,64										' Read POT value
    	  If FREQ < 2 Then FREQ = 2
    
     For i = 0 To 41 Then
        LCDRam_0[5] = LRead STROKA + i
        GoSub Vyvid
        GoSub SHIFT_STR
     Next i 
GoTo BEGIN            
     
SHIFT_STR:

    For j = 1 To 6 Then
      LCDRam_0[j-1] = LCDRam_0[j]  
    
    Next j
Return

Vyvid:
            For t = 0 To FREQ Then
              Low PORTB								' Line 1, clear port b						
	  	  	  PORTB = LCDRam_0[0] 				' And appropriate DATA to illuminate LEDs of a column
			  High L1
              DelayUS PS  									' Wait a bit to smooth display
			  
	  	  	  Low L1: Low PORTB						' Line 2, clear port b	
	  	  	  PORTB = LCDRam_0[1]					' And appropriate DATA to illuminate LEDs of a column
			  High L2
              DelayUS PS  									' Wait a bit to smooth display
			  
	  	  	  Low L2: Low PORTB						' Line 3, clear port b	
	  	  	  PORTB = LCDRam_0[2]					' And appropriate DATA to illuminate LEDs of a column
			  High L3
              DelayUS PS  									' Wait a bit to smooth display
			  
	  	  	  Low L3: Low PORTB						' Line 4, clear port b	
	  	  	  PORTB = LCDRam_0[3]					' And appropriate DATA to illuminate LEDs of a column
			  High L4
              DelayUS PS  									' Wait a bit to smooth display
			  
	  	  	  Low L4: Low PORTB						' Line 5, clear port b	
	  	  	  PORTB = LCDRam_0[4]					' And appropriate DATA to illuminate LEDs of a column
			  High L5
              DelayUS PS  									' Wait a bit to smooth display
			  
	  	  	  Low L5: Low PORTB						' Line 6, clear port b	
	  	  	  PORTB = LCDRam_0[5]					' And appropriate DATA to illuminate LEDs of a column
			  High L6
              DelayUS PS  									' Wait a bit to smooth display
			  
	  	  	  Low L6: Low PORTB
	  	  	  
	  	  	Next t
                Return  
STROKA:
LData  63, 1, 1, 1, 63, 0     
LData  63, 9, 9, 9, 6, 0     
LData  63, 16, 8, 4, 63, 0 
LData  63, 37, 37, 37, 26, 0 
LData  0, 0, 61, 0, 0, 0 
LData  1, 1, 63, 1, 1, 0 
LData  0, 0, 0, 0, 0, 0 
'LData  63, 1, 1, 1, 63, 0     
     
     
          
